/* $Id: arp.c,v 1.1 2000/04/07 14:28:29 bind Exp $ */

#include "sentinel.h"
#include <stdio.h>

struct	arp_header {
	u_int16_t ar_hrd;	/* format of hardware address */
	u_int16_t ar_pro;	/* format of protocol address */
	u_int8_t  ar_hln;	/* length of hardware address */
	u_int8_t  ar_pln;	/* length of protocol address */
	u_int16_t ar_op;	/* one of: */
	u_int8_t  ar_sha[6];	/* sender hardware address */
	u_int8_t  ar_spa[6];	/* sender protocol address */
	u_int8_t  ar_tha[6];	/* target hardware address */
	u_int8_t  ar_tpa[6];	/* target protocol address */
};

int arptest(void) 
{
  pcap_t *socket;
  u_char *pkt, *pktwire;
  struct pcap_pkthdr pcap_h;
  struct libnet_link_int *link;
  struct arp_header *arp;
  extern u_char fakeaddr[6];
  u_char defaddr[6] = {0,0,0,0,0};
  int i = 0;
  char filter[25];

  link = libnet_open_link_interface(device,errbuf);

  if(!link) {
    perror("libnet_open_link_interface");
    exit(-1);
  }

  if(libnet_init_packet(LIBNET_ARP_H + LIBNET_ETH_H, &pkt) < 0) {
    perror("libnet_init_packet");
    exit(1);
  }
  snprintf(filter,25,"arp src host %s",dst);
  socket = pcap_init(filter);

  libnet_build_ethernet(fakeaddr,fakeaddr,ETHERTYPE_ARP,NULL,0,pkt);
  
  libnet_build_arp(ARPHRD_ETHER,ETHERTYPE_IP, 6, 4, ARPOP_REQUEST,
                    (u_char *)hwsource, (u_char *)&source, defaddr,(u_char *)&dest, NULL, 0,
                      pkt + ETH_H); 

  libnet_write_link_layer(link, device, pkt, LIBNET_ARP_H + LIBNET_ETH_H);
  
  tag = 0;
  signal(SIGALRM,sighandler);
  alarm(1);

  while(i < 5) 
  {
    i++;
    printf("."); fflush(stdout);
    sleep(1); // listen 5 seconds per packet transmitted
    pktwire = (u_char *)pcap_next(socket,&pcap_h);
    if(pktwire != NULL) {
      arp = (struct arp_header *)(pktwire + offset);
      if(ntohs(arp->ar_op) == 2) {
        tag = 1;
	return 1;
      }
    }
    if(i == 5) tag = 1;

  }
  libnet_destroy_packet(&pkt);
  pcap_close(socket);
  libnet_close_link_interface(link);
  return 0;
}
