/* $Id: etherping.c,v 1.1 2000/04/07 14:28:30 bind Exp $ */

#include "sentinel.h"

#define SNAPLEN 128
#define TIMEOUT 1024
#define OPTIMIZE 0

int etherpkt(struct libnet_link_int *);

u_char fakeaddr[6] = { 0xff, 0x00, 0x00, 0x00, 0x00, 0x00 };

int etherping(void)
{
  pcap_t *socket;
  u_char *packet, *target;
  int i = 0;
  struct libnet_link_int *link;
  struct pcap_pkthdr pcap_h;
  struct ip      *ip;
  struct icmp    *icmp;
  
  link = libnet_open_link_interface(device, errbuf);

  if(!link) {
    fprintf(stderr, "libnet_open_link_interface: %s\n", errbuf);
    exit(1);
  }
  socket = pcap_init("icmp");

  etherpkt(link); 
  tag = 0;
  signal(SIGALRM,sighandler);

  while(i < 5) 
  {
    i++;
    printf("."); fflush(stdout);
    sleep(1);
    packet = (u_char *) pcap_next(socket, &pcap_h);

    if(packet != NULL) {
      ip = (struct ip *) (packet + offset);
      icmp = (struct icmp *) (packet + offset + IPHDRSIZE);

      target = inet_ntoa(ip->ip_src);
      if(icmp->icmp_type == 0)
        if(strstr(target,dst) != NULL)
  	if(ntohs(icmp->icmp_hun.ih_idseq.icd_id) == 31337) {
	  tag = 1;
	  pcap_close(socket);
	  return 1;
	}
    }  
    if(i == 5) tag = 1;
  }
  pcap_close(socket);
  return 0;
}

int etherpkt(struct libnet_link_int * link)
{
  u_char *pkt;
  int n;


  if(libnet_init_packet(LIBNET_ICMP_ECHO_H + LIBNET_ETH_H + 
                          LIBNET_IP_H, &pkt) < 0) {
    perror("libnet_init_packet");
    exit(1);
  }

  libnet_build_ethernet(fakeaddr, (u_char *)hwsource, ETHERTYPE_IP,NULL, 0, pkt);

  libnet_build_ip(LIBNET_ICMP_ECHO_H, 0, 100, 0, 64, IPPROTO_ICMP,
			source, dest, NULL, 0, pkt + LIBNET_ETH_H);

  libnet_build_icmp_echo(ICMP_ECHO, 0, 0x7a69, 1, NULL, 0, pkt +
			       LIBNET_IP_H + LIBNET_ETH_H);

  libnet_do_checksum(pkt + LIBNET_ETH_H, IPPROTO_IP, LIBNET_IP_H);
  libnet_do_checksum(pkt + LIBNET_ETH_H, IPPROTO_ICMP,LIBNET_ICMP_ECHO_H);


  n = libnet_write_link_layer(link, device, pkt, LIBNET_ICMP_H +
 			        LIBNET_IP_H + LIBNET_ETH_H + 4);

  libnet_close_link_interface(link);
  libnet_destroy_packet(&pkt);
  return n;
}
